#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define LENGTH 50
#define NUMBER_OF_PEOPLE 5

enum gender {MALE, FEMALE};

struct name_forms
{
    char male_name[LENGTH], female_name[LENGTH];
} names[] = {{.male_name = "Andrew", .female_name = "Anne"},
             {.male_name="Edward", .female_name="Katherina"},
             {.male_name="Henry", .female_name="Margaret"},
             {.male_name="John", .female_name="Barbara"},
             {.male_name="Jacob", .female_name="Joanna"}};

char surnames[NUMBER_OF_PEOPLE][LENGTH] = {"Smith", "Brown", "Green", "White", "Johnson"};


struct personal_data
{
    char name[LENGTH], surname[LENGTH];
    unsigned char age;
} people_data[NUMBER_OF_PEOPLE];


struct personal_data get_randomized_data(struct name_forms names[], char surnames[][LENGTH])
{
   struct personal_data person;

   person.age = 1+rand()%120;
   strncpy(person.surname, surnames[rand()%NUMBER_OF_PEOPLE], LENGTH-1);
   unsigned char gender = rand()%2;
   if(gender==FEMALE)
        strncpy(person.name,names[rand()%NUMBER_OF_PEOPLE].female_name,LENGTH-1);
   else
       strncpy(person.name,names[rand()%NUMBER_OF_PEOPLE].male_name,LENGTH-1);

   return person;
}

void fill_array(struct personal_data array[], struct name_forms names[], char surnames[][LENGTH])
{
    srand(time(0));
    int i;
    for(i=0;i<NUMBER_OF_PEOPLE;i++)
        array[i]=get_randomized_data(names, surnames);
}

void print_array(struct personal_data array[])
{
    int i;
    for(i=0;i<NUMBER_OF_PEOPLE;i++) {
        printf("Name: %s\n",array[i].name);
        printf("Surname: %s\n",array[i].surname);
        printf("Age: %u\n",array[i].age);
        puts("");
    }
}

int main(void)
{
    fill_array(people_data, names, surnames);
    print_array(people_data);
    return 0;
}
